/* Generated by Edge Impulse
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
// Generated on: 25.01.2023 18:10:46

#include <stdio.h>
#include <stdlib.h>
#include "edge-impulse-sdk/tensorflow/lite/c/builtin_op_data.h"
#include "edge-impulse-sdk/tensorflow/lite/c/common.h"
#include "edge-impulse-sdk/tensorflow/lite/micro/micro_mutable_op_resolver.h"
#include "edge-impulse-sdk/porting/ei_classifier_porting.h"

#if EI_CLASSIFIER_PRINT_STATE
#if defined(__cplusplus) && EI_C_LINKAGE == 1
extern "C" {
    extern void ei_printf(const char *format, ...);
}
#else
extern void ei_printf(const char *format, ...);
#endif
#endif

#if defined __GNUC__
#define ALIGN(X) __attribute__((aligned(X)))
#elif defined _MSC_VER
#define ALIGN(X) __declspec(align(X))
#elif defined __TASKING__
#define ALIGN(X) __align(X)
#endif

#ifndef EI_MAX_SCRATCH_BUFFER_COUNT
#define EI_MAX_SCRATCH_BUFFER_COUNT 4
#endif // EI_MAX_SCRATCH_BUFFER_COUNT

#ifndef EI_MAX_OVERFLOW_BUFFER_COUNT
#define EI_MAX_OVERFLOW_BUFFER_COUNT 10
#endif // EI_MAX_OVERFLOW_BUFFER_COUNT

using namespace tflite;
using namespace tflite::ops;
using namespace tflite::ops::micro;

namespace {

constexpr int kTensorArenaSize = 7024;

#if defined(EI_CLASSIFIER_ALLOCATION_STATIC)
uint8_t tensor_arena[kTensorArenaSize] ALIGN(16);
#elif defined(EI_CLASSIFIER_ALLOCATION_STATIC_HIMAX)
#pragma Bss(".tensor_arena")
uint8_t tensor_arena[kTensorArenaSize] ALIGN(16);
#pragma Bss()
#elif defined(EI_CLASSIFIER_ALLOCATION_STATIC_HIMAX_GNU)
uint8_t tensor_arena[kTensorArenaSize] ALIGN(16) __attribute__((section(".tensor_arena")));
#else
#define EI_CLASSIFIER_ALLOCATION_HEAP 1
uint8_t* tensor_arena = NULL;
#endif

static uint8_t* tensor_boundary;
static uint8_t* current_location;

template <int SZ, class T> struct TfArray {
  int sz; T elem[SZ];
};
enum used_operators_e {
  OP_RESHAPE, OP_CONV_2D, OP_MAX_POOL_2D, OP_FULLY_CONNECTED, OP_SOFTMAX,  OP_LAST
};
struct TensorInfo_t { // subset of TfLiteTensor used for initialization from constant memory
  TfLiteAllocationType allocation_type;
  TfLiteType type;
  void* data;
  TfLiteIntArray* dims;
  size_t bytes;
  TfLiteQuantization quantization;
};
struct NodeInfo_t { // subset of TfLiteNode used for initialization from constant memory
  struct TfLiteIntArray* inputs;
  struct TfLiteIntArray* outputs;
  void* builtin_data;
  used_operators_e used_op_index;
};

TfLiteContext ctx{};
TfLiteTensor tflTensors[23];
TfLiteEvalTensor tflEvalTensors[23];
TfLiteRegistration registrations[OP_LAST];
TfLiteNode tflNodes[11];

const TfArray<2, int> tensor_dimension0 = { 2, { 1,2960 } };
const TfArray<1, float> quant0_scale = { 1, { 0.0034160539507865906, } };
const TfArray<1, int> quant0_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant0 = { (TfLiteFloatArray*)&quant0_scale, (TfLiteIntArray*)&quant0_zero, 0 };
const ALIGN(16) int32_t tensor_data1[4] = { 1, 1, 74, 40, };
const TfArray<1, int> tensor_dimension1 = { 1, { 4 } };
const ALIGN(16) int32_t tensor_data2[4] = { 1, 74, 1, 8, };
const TfArray<1, int> tensor_dimension2 = { 1, { 4 } };
const ALIGN(16) int32_t tensor_data3[4] = { 1, 1, 37, 8, };
const TfArray<1, int> tensor_dimension3 = { 1, { 4 } };
const ALIGN(16) int32_t tensor_data4[4] = { 1, 37, 1, 16, };
const TfArray<1, int> tensor_dimension4 = { 1, { 4 } };
const ALIGN(8) int32_t tensor_data5[2] = { -1, 304, };
const TfArray<1, int> tensor_dimension5 = { 1, { 2 } };
const ALIGN(16) int8_t tensor_data6[8*1*3*40] = { 
  /* [0][0][][] */ -66,-49,8,67,-38,-59,-54,-14,-8,-46,-78,3,-9,-2,-11,-37,-51,81,10,56,-107,-77,-79,-50,44,39,-78,-94,22,52,-29,1,-52,1,15,-44,-89,49,-17,37, 32,-66,-57,19,3,-21,-26,-77,-70,79,62,38,-71,33,15,95,-9,-24,-42,-54,-33,-26,-38,-76,-14,-21,-24,-11,36,44,-53,54,11,-15,-70,-127,-49,-57,36,47, 77,-51,0,79,-35,84,9,26,-29,-9,50,6,-30,50,2,-90,28,-6,-52,35,20,-36,-91,-56,15,77,-48,-6,-3,56,22,20,34,38,6,-51,-1,-37,56,-74, 
  /* [1][0][][] */ 77,-61,-57,-6,-36,-43,-37,-5,-8,-53,-65,-88,-11,-16,62,76,13,32,-4,-7,-6,64,109,51,9,-7,-3,10,-6,31,25,31,35,45,43,3,16,-47,-72,-80, -4,-52,-25,-51,-34,-40,-23,-61,7,-93,-97,-63,-36,2,73,77,9,24,31,6,25,80,127,32,7,9,10,5,13,27,19,48,38,38,40,49,-17,-30,-66,-98, 27,-69,-47,20,-44,-82,-13,-20,-31,-93,-107,-96,-1,-35,87,59,10,-16,-12,-8,8,60,110,27,-27,-8,17,10,18,11,34,3,24,64,45,50,12,-30,-58,-100, 
  /* [2][0][][] */ 70,-16,7,-41,-103,-32,65,11,49,-51,-43,-3,-22,-65,-52,-49,-63,1,-21,25,9,-4,-96,-6,-12,-53,-62,-62,-94,-30,-58,-4,24,-63,-41,28,8,-33,-39,7, -47,-34,-29,-25,31,6,-55,25,-43,-44,90,13,57,23,-59,7,19,49,-47,-37,-47,-26,-32,-53,-11,-9,-72,-2,35,-81,-68,-35,-62,-68,0,-44,-16,-23,87,-27, -68,-3,-28,-44,58,32,64,112,-7,80,-89,29,12,47,-29,13,-77,-22,-60,-127,45,-75,-49,-6,-69,-13,60,-14,-55,-107,-57,-22,-12,-61,-86,28,4,3,72,25, 
  /* [3][0][][] */ -40,88,118,21,52,-37,-10,35,-37,45,58,81,55,37,-26,36,66,48,-38,4,53,47,-22,16,109,48,-31,-55,-49,9,-38,-54,-59,-70,-62,-46,-110,-17,-24,-35, 76,101,37,-21,55,11,42,40,2,-35,35,76,16,17,-21,49,44,111,38,-24,41,-26,-37,-6,19,44,-9,31,1,-35,4,-57,-24,-78,-65,-127,-98,-78,-57,4, -14,80,29,0,26,-44,30,-6,42,26,67,96,-7,53,-13,17,81,23,5,45,23,-21,-77,2,16,40,-107,-14,-51,-43,-55,-106,-103,-87,-40,-33,-98,-54,-46,11, 
  /* [4][0][][] */ -65,-16,4,-17,40,-69,-25,-5,-76,-11,-22,-82,-31,-11,3,-84,-10,-95,6,-2,-27,-2,5,-80,52,-28,-44,-49,31,-94,-72,-66,18,-42,-87,-29,9,-9,-28,-86, 7,11,19,-16,-74,19,-68,6,-69,60,3,-67,0,-43,-49,-85,48,-27,-12,50,18,-109,-104,-26,-35,16,-7,-66,-27,-29,36,-3,-127,8,-15,-45,19,-125,-4,-31, 2,-51,5,-24,-66,1,-54,-8,-4,-22,49,-21,-1,-22,9,-31,-83,-41,-98,-8,-41,-78,77,-115,-36,-68,-43,11,-42,4,11,-83,26,4,-73,-24,-57,-70,-15,9, 
  /* [5][0][][] */ -12,50,-31,25,52,-13,-22,61,54,-30,-102,-18,12,73,87,19,7,-39,-110,6,-78,51,-6,-54,-127,-40,-22,-6,-35,-111,-120,51,-90,-47,-13,35,-38,-56,-104,31, 11,-20,38,62,-82,15,59,13,49,92,-34,-34,-28,-52,53,-32,-60,35,10,-33,-11,-29,-83,-82,-43,-83,-45,1,9,-112,-11,-64,-32,8,-22,-92,-37,21,52,-33, -59,-3,-9,-64,41,53,4,78,-6,-66,108,20,-62,29,-32,34,42,-85,-49,-77,-29,-17,45,-41,-53,-19,-29,8,-45,-102,-96,-30,-75,-79,-69,-69,-45,8,-8,-43, 
  /* [6][0][][] */ -61,-127,-45,24,-61,-41,-16,39,10,-3,-23,-39,103,4,-5,-1,-23,-86,24,-35,-63,-92,-102,-63,11,-5,-46,-80,39,51,-29,-51,2,18,-41,-27,-1,-21,38,87, 0,-126,-16,40,-20,-116,-8,-37,-5,4,-76,56,26,10,-77,-49,-34,12,2,28,30,24,-66,-43,-37,-34,-9,19,17,40,9,6,-6,-10,-37,-35,-23,11,37,76, -14,-16,-26,106,-82,-40,-23,-39,-72,49,26,-18,37,-56,9,-16,-31,-25,-29,5,37,-56,-69,-41,12,-61,40,6,26,54,9,-3,3,-28,-25,-31,29,10,37,45, 
  /* [7][0][][] */ -2,-38,-32,-45,-4,-52,7,-40,-3,-53,-22,-68,-12,0,-81,-84,-43,-11,-61,30,52,-1,47,95,66,46,-88,-101,12,-30,-38,-18,-22,-21,3,14,-30,-127,-102,-98, 62,-62,24,6,-10,46,16,20,7,-32,-8,-58,-18,-81,-108,-77,-74,-9,30,-77,-34,-3,60,-28,66,18,-14,-94,-32,-16,18,-58,10,73,-53,-32,55,-57,-24,-44, -14,-61,-34,20,-22,9,65,-56,-52,-18,-32,-19,-3,-45,-77,-22,-51,-40,-17,63,19,95,44,90,66,39,18,-39,-49,-70,-60,-82,28,45,25,16,-48,-13,-1,-75, 
};
const TfArray<4, int> tensor_dimension6 = { 4, { 8,1,3,40 } };
const TfArray<8, float> quant6_scale = { 8, { 0.0066406913101673126, 0.0063828295096755028, 0.0058529004454612732, 0.0057205981574952602, 0.0058822371065616608, 0.0061408523470163345, 0.0070930966176092625, 0.0066121835261583328, } };
const TfArray<8, int> quant6_zero = { 8, { 0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant6 = { (TfLiteFloatArray*)&quant6_scale, (TfLiteIntArray*)&quant6_zero, 0 };
const ALIGN(16) int32_t tensor_data7[8] = { 11552, -41622, -6951, -3123, -755, 18042, 7398, -4926, };
const TfArray<1, int> tensor_dimension7 = { 1, { 8 } };
const TfArray<8, float> quant7_scale = { 8, { 2.2684960640617646e-05, 2.1804089556098916e-05, 1.9993824025732465e-05, 1.9541872461559251e-05, 2.0094039427931421e-05, 2.0977482563466765e-05, 2.4230401322711259e-05, 2.2587575585930608e-05, } };
const TfArray<8, int> quant7_zero = { 8, { 0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant7 = { (TfLiteFloatArray*)&quant7_scale, (TfLiteIntArray*)&quant7_zero, 0 };
const ALIGN(16) int8_t tensor_data8[16*1*3*8] = { 
  /* [0][0][][] */ -96,-23,-75,43,-38,-127,72,-87, -33,-25,-70,-57,-44,-122,9,-78, -21,-31,4,49,11,-54,-11,-16, 
  /* [1][0][][] */ -89,48,-95,-2,-39,-85,-3,-101, -93,18,-32,3,-109,-94,-48,-124, -33,49,-13,-15,-67,-61,-91,-127, 
  /* [2][0][][] */ -87,43,-44,-50,-26,-25,-101,-98, -56,-1,-51,17,-31,-71,-127,-69, -51,-43,-59,-9,-67,-73,-22,-47, 
  /* [3][0][][] */ 10,-42,11,-45,12,57,4,5, 2,-118,-46,-14,74,0,-33,4, -23,-127,36,-5,30,5,2,-30, 
  /* [4][0][][] */ -70,-19,-24,-39,23,-68,-51,-5, -90,-76,-26,-45,-44,-105,-15,21, 20,-67,18,-29,-51,89,-127,32, 
  /* [5][0][][] */ -54,-29,-116,-44,29,-50,14,4, 0,-117,-70,-28,46,-58,5,-85, -127,-73,-23,-73,-10,-36,-64,31, 
  /* [6][0][][] */ -26,54,-29,21,-15,51,-40,-30, -43,-3,-49,-19,-4,-11,-66,-48, -45,33,-26,-41,-18,-39,-52,-127, 
  /* [7][0][][] */ -111,-85,-47,6,-70,-11,4,-18, 29,-82,-114,-18,-19,-2,-5,-127, -66,-117,-18,-13,-35,-51,-29,9, 
  /* [8][0][][] */ -85,-35,32,-29,-31,-17,43,0, -16,-97,-11,-32,-22,22,-59,6, -62,-127,11,-30,-13,-73,6,-39, 
  /* [9][0][][] */ -127,-12,-51,7,-29,34,-106,-81, -77,54,-40,-12,-1,-29,-48,-72, -74,1,41,9,-26,-97,-20,-78, 
  /* [10][0][][] */ -1,-21,-34,-58,-10,-105,7,38, 34,-27,0,-44,8,-92,24,-63, -28,-10,-24,-127,-46,-96,28,-15, 
  /* [11][0][][] */ -42,-75,19,-26,-34,-32,-48,-23, -38,-31,41,-31,-50,-41,22,22, -3,-72,-36,21,19,-127,15,-21, 
  /* [12][0][][] */ -31,-10,-127,-75,-16,-34,-90,-51, -102,-12,-37,-58,-54,-98,-5,90, -47,3,-9,-68,-74,31,-86,44, 
  /* [13][0][][] */ -127,-6,-120,48,-118,-47,-110,-7, -19,-16,-83,1,-63,-64,-118,12, -46,-3,-18,58,-86,-86,-19,86, 
  /* [14][0][][] */ -89,-62,-56,-25,-121,57,-72,-105, -36,5,-118,-13,14,-6,-127,-77, -100,23,-44,-78,-30,-7,-49,-83, 
  /* [15][0][][] */ 6,-45,9,38,-55,-51,-123,-33, -94,-42,63,-71,50,-25,53,-10, -5,-46,-78,-127,-76,-21,-122,-7, 
};
const TfArray<4, int> tensor_dimension8 = { 4, { 16,1,3,8 } };
const TfArray<16, float> quant8_scale = { 16, { 0.0053001493215560913, 0.0075998795218765736, 0.0085577666759490967, 0.005215534009039402, 0.0045679695904254913, 0.0050065731629729271, 0.0092494012787938118, 0.0052016228437423706, 0.0051845824345946312, 0.0070483461022377014, 0.0089043304324150085, 0.0052890507504343987, 0.0046486393548548222, 0.0055448040366172791, 0.0034520782064646482, 0.0046223709359765053, } };
const TfArray<16, int> quant8_zero = { 16, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant8 = { (TfLiteFloatArray*)&quant8_scale, (TfLiteIntArray*)&quant8_zero, 0 };
const ALIGN(16) int32_t tensor_data9[16] = { -819, -4425, -4783, -1936, -4535, -6841, -3771, -6195, -5567, -4242, -245, -7450, -8280, -191, -10881, -7891, };
const TfArray<1, int> tensor_dimension9 = { 1, { 16 } };
const TfArray<16, float> quant9_scale = { 16, { 5.8734818594530225e-05, 8.4219806012697518e-05, 9.4834853371139616e-05, 5.7797133194981143e-05, 5.0621001719264314e-05, 5.5481486924691126e-05, 0.00010249936167383566, 5.7642973843030632e-05, 5.7454137277090922e-05, 7.8107863373588771e-05, 9.8675380286294967e-05, 5.8611825807020068e-05, 5.151496225153096e-05, 6.144601502455771e-05, 3.8254995160968974e-05, 5.1223862101323903e-05, } };
const TfArray<16, int> quant9_zero = { 16, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant9 = { (TfLiteFloatArray*)&quant9_scale, (TfLiteIntArray*)&quant9_zero, 0 };
const ALIGN(16) int8_t tensor_data10[2*304] = { 
  43, -106, 3, -26, -43, 1, -34, 46, 22, -2, 52, 20, -15, 76, 5, 48, 39, -40, -2, -17, 15, -37, 3, -25, -33, -83, 97, 2, -19, 81, 3, 4, 43, -41, -69, -17, -16, -26, -33, 11, -18, -19, 83, 23, -46, 32, 5, 25, 41, -58, 32, 9, 3, -5, -55, 38, 3, -69, 69, -21, -20, 30, -18, 23, -10, -57, -112, -51, 22, -32, -25, -60, -21, -84, -9, 28, -4, 63, -48, -4, 9, 0, 32, -25, -55, 15, -42, 18, -77, -30, 48, -4, 52, 39, -33, 17, 66, -27, -24, 31, -12, -1, 8, 6, 18, -15, 64, -17, 47, 16, 2, 33, 29, -92, -50, 36, 5, -33, -33, 11, 38, -22, -2, 78, 12, 45, 1, -18, -14, -46, -45, 73, 1, 33, -48, 50, 63, -28, 30, 35, -59, 8, -21, 16, -18, -127, -47, 60, 14, 32, -125, 16, 63, -45, 66, 14, -53, -43, 8, 44, 45, -66, -36, 70, -6, -42, -44, 29, -18, -67, 20, 24, -14, 5, 10, -38, -26, -33, -17, 25, 16, 30, -35, -11, -21, -3, 24, 21, 13, 38, -23, -11, 28, -38, -28, 0, 17, 5, -53, -13, 11, -48, 71, 16, 80, 23, -68, 22, 36, -36, -63, -17, -4, -9, -6, 25, -29, -35, 71, -45, -25, 9, -19, 53, 46, -18, -14, -2, 4, 32, -26, -40, -41, -5, 29, -48, 17, 22, -3, 12, 9, -6, -69, 10, 13, -27, -29, -23, 5, -5, 58, -14, 77, 82, -39, 15, 82, -46, -17, 2, -45, 31, -28, -32, -39, -16, -3, -39, 11, 36, 12, -8, 41, -33, -107, -49, -18, 49, -44, 29, -19, -25, 58, -26, 28, 97, -1, -7, 6, -56, -61, -52, 7, -15, -22, -3, -36, -22, 56, -1, 64, 42, -25, -18, 
  -35, 50, -8, 24, 69, -5, 62, -28, -15, 12, -50, -11, 13, -75, -16, -79, -17, 20, 36, 21, -30, 46, -20, 16, -8, 66, -44, -22, 25, -67, 7, 32, -47, 47, 74, -8, 18, -6, 53, -22, -14, 42, -71, 16, 28, -61, 16, -11, -19, 61, -13, 17, -1, 4, 44, -10, 15, 30, -37, 19, 21, -74, 21, -5, -7, 73, 101, -7, -26, 6, 48, 82, 17, 38, -14, -25, -11, -49, 23, -8, -34, 11, 2, 1, 36, -32, 79, -33, 50, -10, -52, -37, -64, -26, 38, -16, -48, 61, 72, -25, 9, -1, 33, -9, 10, 24, -65, 23, -84, -30, 7, -32, -17, 72, 55, -41, -26, -13, 33, 5, -13, 25, 11, -52, -23, -62, 12, 15, 10, 44, 54, -42, 15, -48, 45, -32, -17, 27, 2, -17, 57, 24, 22, -16, 23, 99, 71, -18, 12, -44, 123, -33, -30, 58, -35, -5, 71, 31, 13, -88, -47, 88, 72, -51, 22, 33, 42, 5, -31, 30, 12, -41, -32, 14, 37, 12, 53, 61, 19, -2, -61, -44, 66, 14, -31, 43, -21, -1, -19, -27, 5, 11, -28, 40, 4, -30, 25, -22, 60, 2, 29, 28, -62, 3, -65, -21, 71, 2, 6, 15, 92, 9, -8, -19, 10, -18, -19, 49, -84, 28, 40, -18, -1, -53, -28, 15, 37, 28, 46, 5, 35, 20, 46, 42, -34, 30, -9, -68, 38, 18, -36, 15, 86, 25, -39, 30, -7, 20, -6, 44, -45, -16, -73, -77, 49, -30, -34, 54, 58, 16, 31, 22, 56, 19, 18, 21, -46, 23, -4, -58, 21, 10, -33, 33, 61, 43, -29, -54, 73, -26, -19, 17, -41, 11, -38, -118, 4, 1, 4, 54, 73, 59, -46, -5, -2, 16, 5, 33, 0, 11, -58, -83, 21, 62, 
};
const TfArray<2, int> tensor_dimension10 = { 2, { 2,304 } };
const TfArray<1, float> quant10_scale = { 1, { 0.0046907467767596245, } };
const TfArray<1, int> quant10_zero = { 1, { 0 } };
const TfLiteAffineQuantization quant10 = { (TfLiteFloatArray*)&quant10_scale, (TfLiteIntArray*)&quant10_zero, 0 };
const ALIGN(8) int32_t tensor_data11[2] = { 8479, -8479, };
const TfArray<1, int> tensor_dimension11 = { 1, { 2 } };
const TfArray<1, float> quant11_scale = { 1, { 3.6004264984512702e-05, } };
const TfArray<1, int> quant11_zero = { 1, { 0 } };
const TfLiteAffineQuantization quant11 = { (TfLiteFloatArray*)&quant11_scale, (TfLiteIntArray*)&quant11_zero, 0 };
const TfArray<4, int> tensor_dimension12 = { 4, { 1,1,74,40 } };
const TfArray<1, float> quant12_scale = { 1, { 0.0034160539507865906, } };
const TfArray<1, int> quant12_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant12 = { (TfLiteFloatArray*)&quant12_scale, (TfLiteIntArray*)&quant12_zero, 0 };
const TfArray<4, int> tensor_dimension13 = { 4, { 1,1,74,8 } };
const TfArray<1, float> quant13_scale = { 1, { 0.011081729084253311, } };
const TfArray<1, int> quant13_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant13 = { (TfLiteFloatArray*)&quant13_scale, (TfLiteIntArray*)&quant13_zero, 0 };
const TfArray<4, int> tensor_dimension14 = { 4, { 1,74,1,8 } };
const TfArray<1, float> quant14_scale = { 1, { 0.011081729084253311, } };
const TfArray<1, int> quant14_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant14 = { (TfLiteFloatArray*)&quant14_scale, (TfLiteIntArray*)&quant14_zero, 0 };
const TfArray<4, int> tensor_dimension15 = { 4, { 1,37,1,8 } };
const TfArray<1, float> quant15_scale = { 1, { 0.011081729084253311, } };
const TfArray<1, int> quant15_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant15 = { (TfLiteFloatArray*)&quant15_scale, (TfLiteIntArray*)&quant15_zero, 0 };
const TfArray<4, int> tensor_dimension16 = { 4, { 1,1,37,8 } };
const TfArray<1, float> quant16_scale = { 1, { 0.011081729084253311, } };
const TfArray<1, int> quant16_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant16 = { (TfLiteFloatArray*)&quant16_scale, (TfLiteIntArray*)&quant16_zero, 0 };
const TfArray<4, int> tensor_dimension17 = { 4, { 1,1,37,16 } };
const TfArray<1, float> quant17_scale = { 1, { 0.0076755932532250881, } };
const TfArray<1, int> quant17_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant17 = { (TfLiteFloatArray*)&quant17_scale, (TfLiteIntArray*)&quant17_zero, 0 };
const TfArray<4, int> tensor_dimension18 = { 4, { 1,37,1,16 } };
const TfArray<1, float> quant18_scale = { 1, { 0.0076755932532250881, } };
const TfArray<1, int> quant18_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant18 = { (TfLiteFloatArray*)&quant18_scale, (TfLiteIntArray*)&quant18_zero, 0 };
const TfArray<4, int> tensor_dimension19 = { 4, { 1,19,1,16 } };
const TfArray<1, float> quant19_scale = { 1, { 0.0076755932532250881, } };
const TfArray<1, int> quant19_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant19 = { (TfLiteFloatArray*)&quant19_scale, (TfLiteIntArray*)&quant19_zero, 0 };
const TfArray<2, int> tensor_dimension20 = { 2, { 1,304 } };
const TfArray<1, float> quant20_scale = { 1, { 0.0076755932532250881, } };
const TfArray<1, int> quant20_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant20 = { (TfLiteFloatArray*)&quant20_scale, (TfLiteIntArray*)&quant20_zero, 0 };
const TfArray<2, int> tensor_dimension21 = { 2, { 1,2 } };
const TfArray<1, float> quant21_scale = { 1, { 0.082574240863323212, } };
const TfArray<1, int> quant21_zero = { 1, { -5 } };
const TfLiteAffineQuantization quant21 = { (TfLiteFloatArray*)&quant21_scale, (TfLiteIntArray*)&quant21_zero, 0 };
const TfArray<2, int> tensor_dimension22 = { 2, { 1,2 } };
const TfArray<1, float> quant22_scale = { 1, { 0.00390625, } };
const TfArray<1, int> quant22_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant22 = { (TfLiteFloatArray*)&quant22_scale, (TfLiteIntArray*)&quant22_zero, 0 };
const TfLiteReshapeParams opdata0 = { { 0, 0, 0, 0, 0, 0, 0, 0, }, 0 };
const TfArray<2, int> inputs0 = { 2, { 0,1 } };
const TfArray<1, int> outputs0 = { 1, { 12 } };
const TfLiteConvParams opdata1 = { kTfLitePaddingSame, 1,1, kTfLiteActRelu, 1,1 };
const TfArray<3, int> inputs1 = { 3, { 12,6,7 } };
const TfArray<1, int> outputs1 = { 1, { 13 } };
const TfLiteReshapeParams opdata2 = { { 0, 0, 0, 0, 0, 0, 0, 0, }, 0 };
const TfArray<2, int> inputs2 = { 2, { 13,2 } };
const TfArray<1, int> outputs2 = { 1, { 14 } };
const TfLitePoolParams opdata3 = { kTfLitePaddingSame, 1,2, 1,2, kTfLiteActNone, { { 0,0, 0, 0 } } };
const TfArray<1, int> inputs3 = { 1, { 14 } };
const TfArray<1, int> outputs3 = { 1, { 15 } };
const TfLiteReshapeParams opdata4 = { { 0, 0, 0, 0, 0, 0, 0, 0, }, 0 };
const TfArray<2, int> inputs4 = { 2, { 15,3 } };
const TfArray<1, int> outputs4 = { 1, { 16 } };
const TfLiteConvParams opdata5 = { kTfLitePaddingSame, 1,1, kTfLiteActRelu, 1,1 };
const TfArray<3, int> inputs5 = { 3, { 16,8,9 } };
const TfArray<1, int> outputs5 = { 1, { 17 } };
const TfLiteReshapeParams opdata6 = { { 0, 0, 0, 0, 0, 0, 0, 0, }, 0 };
const TfArray<2, int> inputs6 = { 2, { 17,4 } };
const TfArray<1, int> outputs6 = { 1, { 18 } };
const TfLitePoolParams opdata7 = { kTfLitePaddingSame, 1,2, 1,2, kTfLiteActNone, { { 0,0, 0, 0 } } };
const TfArray<1, int> inputs7 = { 1, { 18 } };
const TfArray<1, int> outputs7 = { 1, { 19 } };
const TfLiteReshapeParams opdata8 = { { 0, 0, 0, 0, 0, 0, 0, 0, }, 0 };
const TfArray<2, int> inputs8 = { 2, { 19,5 } };
const TfArray<1, int> outputs8 = { 1, { 20 } };
const TfLiteFullyConnectedParams opdata9 = { kTfLiteActNone, kTfLiteFullyConnectedWeightsFormatDefault, false, false };
const TfArray<3, int> inputs9 = { 3, { 20,10,11 } };
const TfArray<1, int> outputs9 = { 1, { 21 } };
const TfLiteSoftmaxParams opdata10 = { 1 };
const TfArray<1, int> inputs10 = { 1, { 21 } };
const TfArray<1, int> outputs10 = { 1, { 22 } };
const TensorInfo_t tensorData[] = {
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 2960, (TfLiteIntArray*)&tensor_dimension0, 2960, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant0))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data1, (TfLiteIntArray*)&tensor_dimension1, 16, {kTfLiteNoQuantization, nullptr}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data2, (TfLiteIntArray*)&tensor_dimension2, 16, {kTfLiteNoQuantization, nullptr}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data3, (TfLiteIntArray*)&tensor_dimension3, 16, {kTfLiteNoQuantization, nullptr}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data4, (TfLiteIntArray*)&tensor_dimension4, 16, {kTfLiteNoQuantization, nullptr}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data5, (TfLiteIntArray*)&tensor_dimension5, 8, {kTfLiteNoQuantization, nullptr}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data6, (TfLiteIntArray*)&tensor_dimension6, 960, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant6))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data7, (TfLiteIntArray*)&tensor_dimension7, 32, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant7))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data8, (TfLiteIntArray*)&tensor_dimension8, 384, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant8))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data9, (TfLiteIntArray*)&tensor_dimension9, 64, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant9))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data10, (TfLiteIntArray*)&tensor_dimension10, 608, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant10))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data11, (TfLiteIntArray*)&tensor_dimension11, 8, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant11))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension12, 2960, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant12))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 2960, (TfLiteIntArray*)&tensor_dimension13, 592, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant13))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension14, 592, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant14))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 592, (TfLiteIntArray*)&tensor_dimension15, 296, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant15))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension16, 296, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant16))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 592, (TfLiteIntArray*)&tensor_dimension17, 592, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant17))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension18, 592, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant18))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 592, (TfLiteIntArray*)&tensor_dimension19, 304, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant19))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension20, 304, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant20))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 304, (TfLiteIntArray*)&tensor_dimension21, 2, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant21))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension22, 2, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant22))}, },
};const NodeInfo_t nodeData[] = {
  { (TfLiteIntArray*)&inputs0, (TfLiteIntArray*)&outputs0, const_cast<void*>(static_cast<const void*>(&opdata0)), OP_RESHAPE, },
  { (TfLiteIntArray*)&inputs1, (TfLiteIntArray*)&outputs1, const_cast<void*>(static_cast<const void*>(&opdata1)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs2, (TfLiteIntArray*)&outputs2, const_cast<void*>(static_cast<const void*>(&opdata2)), OP_RESHAPE, },
  { (TfLiteIntArray*)&inputs3, (TfLiteIntArray*)&outputs3, const_cast<void*>(static_cast<const void*>(&opdata3)), OP_MAX_POOL_2D, },
  { (TfLiteIntArray*)&inputs4, (TfLiteIntArray*)&outputs4, const_cast<void*>(static_cast<const void*>(&opdata4)), OP_RESHAPE, },
  { (TfLiteIntArray*)&inputs5, (TfLiteIntArray*)&outputs5, const_cast<void*>(static_cast<const void*>(&opdata5)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs6, (TfLiteIntArray*)&outputs6, const_cast<void*>(static_cast<const void*>(&opdata6)), OP_RESHAPE, },
  { (TfLiteIntArray*)&inputs7, (TfLiteIntArray*)&outputs7, const_cast<void*>(static_cast<const void*>(&opdata7)), OP_MAX_POOL_2D, },
  { (TfLiteIntArray*)&inputs8, (TfLiteIntArray*)&outputs8, const_cast<void*>(static_cast<const void*>(&opdata8)), OP_RESHAPE, },
  { (TfLiteIntArray*)&inputs9, (TfLiteIntArray*)&outputs9, const_cast<void*>(static_cast<const void*>(&opdata9)), OP_FULLY_CONNECTED, },
  { (TfLiteIntArray*)&inputs10, (TfLiteIntArray*)&outputs10, const_cast<void*>(static_cast<const void*>(&opdata10)), OP_SOFTMAX, },
};
static void* overflow_buffers[EI_MAX_OVERFLOW_BUFFER_COUNT];
static size_t overflow_buffers_ix = 0;
static void * AllocatePersistentBuffer(struct TfLiteContext* ctx,
                                       size_t bytes) {
  void *ptr;
  if (current_location - bytes < tensor_boundary) {
    if (overflow_buffers_ix > EI_MAX_OVERFLOW_BUFFER_COUNT - 1) {
      ei_printf("ERR: Failed to allocate persistent buffer of size %d, does not fit in tensor arena and reached EI_MAX_OVERFLOW_BUFFER_COUNT\n",
        (int)bytes);
      return NULL;
    }

    // OK, this will look super weird, but.... we have CMSIS-NN buffers which
    // we cannot calculate beforehand easily.
    ptr = ei_calloc(bytes, 1);
    if (ptr == NULL) {
      ei_printf("ERR: Failed to allocate persistent buffer of size %d\n", (int)bytes);
      return NULL;
    }
    overflow_buffers[overflow_buffers_ix++] = ptr;
    return ptr;
  }

  current_location -= bytes;

  ptr = current_location;
  memset(ptr, 0, bytes);

  return ptr;
}
typedef struct {
  size_t bytes;
  void *ptr;
} scratch_buffer_t;
static scratch_buffer_t scratch_buffers[EI_MAX_SCRATCH_BUFFER_COUNT];
static size_t scratch_buffers_ix = 0;

static TfLiteStatus RequestScratchBufferInArena(struct TfLiteContext* ctx, size_t bytes,
                                                int* buffer_idx) {
  if (scratch_buffers_ix > EI_MAX_SCRATCH_BUFFER_COUNT - 1) {
    ei_printf("ERR: Failed to allocate scratch buffer of size %d, reached EI_MAX_SCRATCH_BUFFER_COUNT\n",
      (int)bytes);
    return kTfLiteError;
  }

  scratch_buffer_t b;
  b.bytes = bytes;

  b.ptr = AllocatePersistentBuffer(ctx, b.bytes);
  if (!b.ptr) {
    ei_printf("ERR: Failed to allocate scratch buffer of size %d\n",
      (int)bytes);
    return kTfLiteError;
  }

  scratch_buffers[scratch_buffers_ix] = b;
  *buffer_idx = scratch_buffers_ix;

  scratch_buffers_ix++;

  return kTfLiteOk;
}

static void* GetScratchBuffer(struct TfLiteContext* ctx, int buffer_idx) {
  if (buffer_idx > (int)scratch_buffers_ix) {
    return NULL;
  }
  return scratch_buffers[buffer_idx].ptr;
}

static TfLiteTensor* GetTensor(const struct TfLiteContext* context,
                               int tensor_idx) {
  return &tflTensors[tensor_idx];
}

static TfLiteEvalTensor* GetEvalTensor(const struct TfLiteContext* context,
                                       int tensor_idx) {
  return &tflEvalTensors[tensor_idx];
}

} // namespace

TfLiteStatus trained_model_init( void*(*alloc_fnc)(size_t,size_t) ) {
#ifdef EI_CLASSIFIER_ALLOCATION_HEAP
  tensor_arena = (uint8_t*) alloc_fnc(16, kTensorArenaSize);
  if (!tensor_arena) {
    ei_printf("ERR: failed to allocate tensor arena\n");
    return kTfLiteError;
  }
#else
  memset(tensor_arena, 0, kTensorArenaSize);
#endif
  tensor_boundary = tensor_arena;
  current_location = tensor_arena + kTensorArenaSize;
  ctx.AllocatePersistentBuffer = &AllocatePersistentBuffer;
  ctx.RequestScratchBufferInArena = &RequestScratchBufferInArena;
  ctx.GetScratchBuffer = &GetScratchBuffer;
  ctx.GetTensor = &GetTensor;
  ctx.GetEvalTensor = &GetEvalTensor;
  ctx.tensors = tflTensors;
  ctx.tensors_size = 23;
  for (size_t i = 0; i < 23; ++i) {
    tflTensors[i].type = tensorData[i].type;
    tflEvalTensors[i].type = tensorData[i].type;
    tflTensors[i].is_variable = 0;

#if defined(EI_CLASSIFIER_ALLOCATION_HEAP)
    tflTensors[i].allocation_type = tensorData[i].allocation_type;
#else
    tflTensors[i].allocation_type = (tensor_arena <= tensorData[i].data && tensorData[i].data < tensor_arena + kTensorArenaSize) ? kTfLiteArenaRw : kTfLiteMmapRo;
#endif
    tflTensors[i].bytes = tensorData[i].bytes;
    tflTensors[i].dims = tensorData[i].dims;
    tflEvalTensors[i].dims = tensorData[i].dims;

#if defined(EI_CLASSIFIER_ALLOCATION_HEAP)
    if(tflTensors[i].allocation_type == kTfLiteArenaRw){
      uint8_t* start = (uint8_t*) ((uintptr_t)tensorData[i].data + (uintptr_t) tensor_arena);

     tflTensors[i].data.data =  start;
     tflEvalTensors[i].data.data =  start;
    }
    else {
       tflTensors[i].data.data = tensorData[i].data;
       tflEvalTensors[i].data.data = tensorData[i].data;
    }
#else
    tflTensors[i].data.data = tensorData[i].data;
    tflEvalTensors[i].data.data = tensorData[i].data;
#endif // EI_CLASSIFIER_ALLOCATION_HEAP
    tflTensors[i].quantization = tensorData[i].quantization;
    if (tflTensors[i].quantization.type == kTfLiteAffineQuantization) {
      TfLiteAffineQuantization const* quant = ((TfLiteAffineQuantization const*)(tensorData[i].quantization.params));
      tflTensors[i].params.scale = quant->scale->data[0];
      tflTensors[i].params.zero_point = quant->zero_point->data[0];
    }
    if (tflTensors[i].allocation_type == kTfLiteArenaRw) {
      auto data_end_ptr = (uint8_t*)tflTensors[i].data.data + tensorData[i].bytes;
      if (data_end_ptr > tensor_boundary) {
        tensor_boundary = data_end_ptr;
      }
    }
  }
  if (tensor_boundary > current_location /* end of arena size */) {
    ei_printf("ERR: tensor arena is too small, does not fit model - even without scratch buffers\n");
    return kTfLiteError;
  }
  registrations[OP_RESHAPE] = Register_RESHAPE();
  registrations[OP_CONV_2D] = Register_CONV_2D();
  registrations[OP_MAX_POOL_2D] = Register_MAX_POOL_2D();
  registrations[OP_FULLY_CONNECTED] = Register_FULLY_CONNECTED();
  registrations[OP_SOFTMAX] = Register_SOFTMAX();

  for (size_t i = 0; i < 11; ++i) {
    tflNodes[i].inputs = nodeData[i].inputs;
    tflNodes[i].outputs = nodeData[i].outputs;
    tflNodes[i].builtin_data = nodeData[i].builtin_data;
tflNodes[i].custom_initial_data = nullptr;
      tflNodes[i].custom_initial_data_size = 0;
if (registrations[nodeData[i].used_op_index].init) {
      tflNodes[i].user_data = registrations[nodeData[i].used_op_index].init(&ctx, (const char*)tflNodes[i].builtin_data, 0);
    }
  }
  for (size_t i = 0; i < 11; ++i) {
    if (registrations[nodeData[i].used_op_index].prepare) {
      TfLiteStatus status = registrations[nodeData[i].used_op_index].prepare(&ctx, &tflNodes[i]);
      if (status != kTfLiteOk) {
        return status;
      }
    }
  }
  return kTfLiteOk;
}

static const int inTensorIndices[] = {
  0, 
};
TfLiteTensor* trained_model_input(int index) {
  return &ctx.tensors[inTensorIndices[index]];
}

static const int outTensorIndices[] = {
  22, 
};
TfLiteTensor* trained_model_output(int index) {
  return &ctx.tensors[outTensorIndices[index]];
}

TfLiteStatus trained_model_invoke() {
  for (size_t i = 0; i < 11; ++i) {
    TfLiteStatus status = registrations[nodeData[i].used_op_index].invoke(&ctx, &tflNodes[i]);

#if EI_CLASSIFIER_PRINT_STATE
    ei_printf("layer %lu\n", i);
    ei_printf("    inputs:\n");
    for (size_t ix = 0; ix < tflNodes[i].inputs->size; ix++) {
      auto d = tensorData[tflNodes[i].inputs->data[ix]];

      size_t data_ptr = (size_t)d.data;

      if (d.allocation_type == kTfLiteArenaRw) {
        data_ptr = (size_t)tensor_arena + data_ptr;
      }

      if (d.type == TfLiteType::kTfLiteInt8) {
        int8_t* data = (int8_t*)data_ptr;
        ei_printf("        %lu (%zu bytes, ptr=%p, alloc_type=%d, type=%d): ", ix, d.bytes, data, (int)d.allocation_type, (int)d.type);
        for (size_t jx = 0; jx < d.bytes; jx++) {
          ei_printf("%d ", data[jx]);
        }
      }
      else {
        float* data = (float*)data_ptr;
        ei_printf("        %lu (%zu bytes, ptr=%p, alloc_type=%d, type=%d): ", ix, d.bytes, data, (int)d.allocation_type, (int)d.type);
        for (size_t jx = 0; jx < d.bytes / 4; jx++) {
          ei_printf("%f ", data[jx]);
        }
      }
      ei_printf("\n");
    }
    ei_printf("\n");

    ei_printf("    outputs:\n");
    for (size_t ix = 0; ix < tflNodes[i].outputs->size; ix++) {
      auto d = tensorData[tflNodes[i].outputs->data[ix]];

      size_t data_ptr = (size_t)d.data;

      if (d.allocation_type == kTfLiteArenaRw) {
        data_ptr = (size_t)tensor_arena + data_ptr;
      }

      if (d.type == TfLiteType::kTfLiteInt8) {
        int8_t* data = (int8_t*)data_ptr;
        ei_printf("        %lu (%zu bytes, ptr=%p, alloc_type=%d, type=%d): ", ix, d.bytes, data, (int)d.allocation_type, (int)d.type);
        for (size_t jx = 0; jx < d.bytes; jx++) {
          ei_printf("%d ", data[jx]);
        }
      }
      else {
        float* data = (float*)data_ptr;
        ei_printf("        %lu (%zu bytes, ptr=%p, alloc_type=%d, type=%d): ", ix, d.bytes, data, (int)d.allocation_type, (int)d.type);
        for (size_t jx = 0; jx < d.bytes / 4; jx++) {
          ei_printf("%f ", data[jx]);
        }
      }
      ei_printf("\n");
    }
    ei_printf("\n");
#endif // EI_CLASSIFIER_PRINT_STATE

    if (status != kTfLiteOk) {
      return status;
    }
  }
  return kTfLiteOk;
}

TfLiteStatus trained_model_reset( void (*free_fnc)(void* ptr) ) {
#ifdef EI_CLASSIFIER_ALLOCATION_HEAP
  free_fnc(tensor_arena);
#endif

  // scratch buffers are allocated within the arena, so just reset the counter so memory can be reused
  scratch_buffers_ix = 0;

  // overflow buffers are on the heap, so free them first
  for (size_t ix = 0; ix < overflow_buffers_ix; ix++) {
    ei_free(overflow_buffers[ix]);
  }
  overflow_buffers_ix = 0;
  return kTfLiteOk;
}
